"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const type = require("./type.js");
function fromMarkdownThink(option) {
  let match = false;
  return {
    enter: {
      [type.ThinkEvent.thinkFlow]: handleThinkOpen,
      // [ThinkEvent.thinkFlowFenceSequence]: handleThinkFenceOpen,
      // [ThinkEvent.thinkFlowCloseFenceSequence]: handleThinkFenceOpen,
      [type.ThinkEvent.thinkFlowValue]: handleThinkValueOpen
    },
    exit: {
      [type.ThinkEvent.thinkFlow]: handleThinkClose,
      // [ThinkEvent.thinkFlowFenceSequence]: handleThinkFenceClose,
      [type.ThinkEvent.thinkFlowValue]: handleThinkValueClose,
      [type.ThinkEvent.thinkFlowCloseFenceSequence]: handlethinkFlowCloseFenceSequence,
      [type.ThinkEvent.lineEnding]: handleLineEnding
    }
  };
  function handleThinkOpen(token) {
    match = true;
    const code = {
      type: "element",
      meta: {
        loading: true
      },
      value: "",
      tagName: "think",
      properties: {
        classname: "thinkContent"
      },
      children: []
    };
    this.enter(
      {
        type: "thinkFlow",
        meta: null,
        value: "",
        data: { hChildren: [code], value: "", loading: true }
      },
      token
    );
  }
  function handleThinkValueOpen(token) {
    this.buffer();
  }
  function getThinkNode() {
    const node = this.stack[this.stack.length - 1];
    const thinkContentEle = node.data.hChildren[0];
    return thinkContentEle;
  }
  function handleThinkValueClose(token) {
    this.resume();
    const value = this.sliceSerialize(token);
    const thinkNode = getThinkNode.call(this);
    thinkNode.children.push({
      type: "text",
      value
    });
    thinkNode.value += value;
  }
  function handlethinkFlowCloseFenceSequence(token) {
    const thinkNode = getThinkNode.call(this);
    thinkNode.meta.loading = false;
  }
  function handleLineEnding(token) {
    if (match) {
      const value = this.sliceSerialize(token);
      console.log("handleLineEnding_value", value);
      this.stack[this.stack.length - 1];
      const code = {
        type: "element",
        value: "",
        tagName: "br",
        properties: { className: ["think-br"] },
        children: []
      };
      const thinkNode = getThinkNode.call(this);
      thinkNode.children.push(code);
      thinkNode.value += value;
      return;
    }
  }
  function handleThinkClose(token) {
    const node = this.stack[this.stack.length - 1];
    console.log("完整handleThinkClose", node);
    this.exit(token);
    match = false;
  }
}
exports.fromMarkdownThink = fromMarkdownThink;
