"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("../node_modules/.pnpm/micromark-factory-space@2.0.1/node_modules/micromark-factory-space/index.js");
const index$1 = require("../node_modules/.pnpm/micromark-util-character@2.1.1/node_modules/micromark-util-character/index.js");
const type = require("./type.js");
const types = require("../node_modules/.pnpm/micromark-util-symbol@2.0.1/node_modules/micromark-util-symbol/lib/types.js");
const codes = require("../node_modules/.pnpm/micromark-util-symbol@2.0.1/node_modules/micromark-util-symbol/lib/codes.js");
const values = require("../node_modules/.pnpm/micromark-util-symbol@2.0.1/node_modules/micromark-util-symbol/lib/values.js");
const constants = require("../node_modules/.pnpm/micromark-util-symbol@2.0.1/node_modules/micromark-util-symbol/lib/constants.js");
const getStrCode = (str) => {
  const key = Object.keys(values.values).find((key2) => values.values[key2] === str);
  return codes.codes[key];
};
const thinkFlow = (options) => {
  const { customTagName = "think" } = options || {};
  if (typeof customTagName !== "string") {
    throw new Error("customTagName must be a string");
  }
  return {
    tokenize: tokenizeThinkFenced,
    concrete: true,
    name: "thinkFlow"
  };
  function tokenizeThinkFenced(effects, ok, nok) {
    const self = this;
    const tail = self.events[self.events.length - 1];
    const initialSize = tail && tail[1].type === types.types.linePrefix ? tail[2].sliceSerialize(tail[1], true).length : 0;
    let thinkState = 0;
    const codeTags = Array.from(customTagName).map((i) => getStrCode(i));
    codeTags.push(codes.codes.greaterThan);
    return start;
    function start(code) {
      if (code !== codes.codes.lessThan) return nok(code);
      effects.enter(type.ThinkEvent.thinkFlow);
      effects.enter(type.ThinkEvent.thinkFlowFence);
      effects.consume(code);
      effects.enter(type.ThinkEvent.thinkFlowFenceSequence);
      return openTag;
    }
    function openTag(code) {
      const strLength = codeTags.length - 1;
      const needCode = codeTags[thinkState];
      if (code !== needCode) return nok(code);
      if (thinkState < strLength) {
        effects.consume(code);
        thinkState++;
        return openTag;
      }
      if (thinkState === codeTags.length - 1 && needCode === codes.codes.greaterThan) {
        effects.consume(code);
        effects.exit(type.ThinkEvent.thinkFlowFenceSequence);
        return index.factorySpace(effects, afterOpenSequence, types.types.whitespace);
      }
      return nok(code);
    }
    function afterOpenSequence(code) {
      if (code === codes.codes.eof || index$1.markdownLineEnding(code)) {
        effects.exit(type.ThinkEvent.thinkFlowFence);
        if (self.interrupt) {
          return ok(code);
        }
        return effects.attempt(nonLazyContinuation, beforeContent, after)(code);
      }
      return nok(code);
    }
    function beforeContent(code) {
      return effects.attempt(
        { tokenize: tokenizeClosingFence, partial: true },
        after,
        contentStart
      )(code);
    }
    function contentStart(code) {
      return (initialSize ? index.factorySpace(
        effects,
        beforeContentChunk,
        types.types.linePrefix,
        initialSize + 1
      ) : beforeContentChunk)(code);
    }
    function beforeContentChunk(code) {
      if (code === codes.codes.eof) {
        return after(code);
      }
      if (index$1.markdownLineEnding(code)) {
        return effects.attempt(nonLazyContinuation, beforeContent, after)(code);
      }
      effects.enter(type.ThinkEvent["thinkFlowValue"]);
      return contentChunk(code);
    }
    function contentChunk(code) {
      if (code === codes.codes.eof || index$1.markdownLineEnding(code)) {
        effects.exit(type.ThinkEvent["thinkFlowValue"]);
        return beforeContentChunk(code);
      }
      effects.consume(code);
      return contentChunk;
    }
    function after(code) {
      effects.exit(type.ThinkEvent.thinkFlow);
      return ok(code);
    }
    function tokenizeClosingFence(effects2, ok2, nok2) {
      let matched = false;
      return index.factorySpace(
        effects2,
        closingPrefixAfter,
        types.types.linePrefix,
        self.parser.constructs.disable.null.includes("codeIndented") ? void 0 : constants.constants.tabSize
      );
      function closingPrefixAfter(code) {
        if (code === codes.codes.lessThan) {
          effects2.enter(type.ThinkEvent.thinkFlowFence);
          effects2.enter(type.ThinkEvent.thinkFlowFenceSequence);
          effects2.enter(type.ThinkEvent.thinkFlowCloseFenceSequence);
          effects2.consume(code);
          return closingSlash;
        }
        return nok2(code);
      }
      function closingSlash(code) {
        if (code === codes.codes.slash) {
          thinkState = 0;
          effects2.consume(code);
          return closingTag;
        }
        return nok2(code);
      }
      function closingTag(code) {
        const strLength = codeTags.length - 1;
        const needCode = codeTags[thinkState];
        if (code !== needCode) return nok2(code);
        if (thinkState < strLength) {
          effects2.consume(code);
          thinkState++;
          return closingTag;
        }
        if (thinkState === codeTags.length - 1 && needCode === codes.codes.greaterThan) {
          matched = true;
          return closingTagEnd(code);
        }
        return nok2(code);
      }
      function closingTagEnd(code) {
        if (code === codes.codes.greaterThan && matched) {
          effects2.consume(code);
          effects2.exit(type.ThinkEvent.thinkFlowCloseFenceSequence);
          effects2.exit(type.ThinkEvent.thinkFlowFenceSequence);
          return index.factorySpace(effects2, closingSequenceEnd, types.types.whitespace);
        }
        return nok2(code);
      }
      function closingSequenceEnd(code) {
        if (code === codes.codes.eof || index$1.markdownLineEnding(code)) {
          effects2.exit(type.ThinkEvent.thinkFlowFence);
          return ok2(code);
        }
        return nok2(code);
      }
    }
  }
};
const nonLazyContinuation = {
  tokenize: tokenizeNonLazyContinuation,
  partial: true
};
function tokenizeNonLazyContinuation(effects, ok, nok) {
  const self = this;
  return start;
  function start(code) {
    if (code === null) {
      return ok(code);
    }
    console.log("expected eol");
    effects.enter(type.ThinkEvent.lineEnding);
    effects.consume(code);
    effects.exit(type.ThinkEvent.lineEnding);
    return lineStart;
  }
  function lineStart(code) {
    return self.parser.lazy[self.now().line] ? nok(code) : ok(code);
  }
}
exports.thinkFlow = thinkFlow;
